

GLOBAL handlerStatic
EXTERN strHandlerStatic, headerHTTP200, headerStd
EXTERN printf, malloc, free, strlen, strcpy, fopen, fclose, fseek, ftell, fread, fprintf, send
EXTERN cfgRoot, fOpenRead, kSocketCall, sendServerHeader

%include 'helpers.asm'

handlerStatic:
    push ebp        ; preserve ebp
    mov ebp, esp    ; new local offset
    
    %define filename ebp + 8
    
    sub esp, 4      ; for filename pointer
    %define fullfilename ebp - 4
    mov dword [fullfilename], dword 0
    
    sub esp, 4      ; for filename pointer
    %define filehandle ebp - 8
    mov dword [filehandle], dword 0
    
    sub esp, 4      ; for filename pointer
    %define filelength ebp - 12
    mov dword [filelength], dword 0
    
    push dword cfgRoot
    call strlen
    add esp, 4

    push eax
    
    push dword [filename]
    call strlen
    add esp, 4
    
    pop edx
    add eax, edx    ; in eax - length of two strings(for full path)
    inc eax         ; eax++ for terminating '0'
    
    push eax                ; count of bytes we need
    call malloc             ; get some memory from system
    add esp, 4
    mov [fullfilename], eax ; save pointer
    test eax, eax           ; what about zero?
    jz .endproc             ; zero pointer?


    push dword cfgRoot          ; copy folder
    push dword [fullfilename]   ; to result path
    call strcpy                 ; do copy
    add esp, 8                  ; correct stack
    
    push dword cfgRoot          ; and again fetch line length
    call strlen                 ; get it
    add esp, 4                  ; correct ..
    
    add eax, [fullfilename]     ; calculate end of string
    
    push dword [filename]       ; file name
    push eax                    ; end of folder prefix
    call strcpy                 ; do copy
    add esp, 4 * 2              ; stack correct
    
    
    push dword [fullfilename]   ; output debug string
    push dword strHandlerStatic
    call printf
    add esp, 4 * 2
    
.fileOpen:    
    push dword fOpenRead        ; 'r'
    push dword [fullfilename]   ; file path
    call fopen                  ; trying to open file
    add esp, 4 * 2              ; correct 
    mov [filehandle], eax       ; save file handler

    cmp eax, 0                  ; check for error
    jz .notfound                ; error(=not found)?

.fileSize:    
    push dword 2                ; SEEK_END constant value
    push dword 0                ; argument
    push dword [filehandle]     ; file handle
    call fseek                  ; move pointer to the end
    add esp, 4 * 3              ; free 12bytes from stack
    
    push dword [filehandle]     ; file handle
    call ftell                  ; where is a file pointer?
    add esp, 4                  ; correct it
    mov [filelength], eax       ; save file length
    
    cmp eax, 0                  ; empty file?
    jz .notfound                ; so, it's like no file
    
.allocMemoryForFile:
    push dword [filelength]
    call malloc
    add esp, 4
    cmp eax, 0
    jz .closeFile
    
    push eax                    ; save memory pointer
    
.readFile:
    push dword 0                ; SEEK_SET constant
    push dword 0                ; offset
    push dword [filehandle]     ; file stream
    call fseek                  ; move pointer to begin
    add esp, 4 * 3              ; and again..

    pop eax
    push eax
    
    push dword [filehandle]     ; file stream
    push dword [filelength]     ; (count) 
    push dword 1                ; size of element (=char)
    push eax                    ; in eax now pointer to memory
    call fread                  ; read to buffer
    add esp, 4 * 4              ; stack.
    
.writeToSocket:

    ; first of all, send HTTP 200 answer
    push dword headerHTTP200    ; string to send
    call strlen                 ; get string length
    add esp, 4                  ; correct stack
        
    push dword 0                ; flags
    push eax                    ; length
    push dword headerHTTP200    ; header string
    mov ebx, dword [ebp+20]     ; start of structure in processRequest
    push dword [ebx+8]          ; socket handle
    mov ecx, esp                ; ptr to struct in stack
    mov ebx, 9                  ; send() function number
    call kSocketCall            ; call it
    add esp, 4 * 4              ; correct stack space

    ; ..and server info
    mov ebx, dword [ebp+20]     ; start of structure in processRequest
    push dword [ebx+8]          ; socket handle is argument (from struct)
    call sendServerHeader       ; call it
    
    ; next, send generic headers
    push dword headerStd        ; string to send
    call strlen                 ; get string length
    add esp, 4                  ; correct stack
        
    push dword 0                ; flags
    push eax                    ; length
    push dword headerStd        ; header string
    mov ebx, dword [ebp+20]     ; start of structure in processRequest
    push dword [ebx+8]          ; socket handle
    mov ecx, esp                ; ptr to struct in stack
    mov ebx, 9                  ; send() function number
    call kSocketCall            ; call it
    add esp, 4 * 4              ; correct stack space

    
    pop edx                     ; addr of buff
    push edx                    ; and save it again
    
    mov ebx, dword [ebp+20]     ; start of structure in processRequest

    ; at last, send file contents
    push dword 0                
    push dword [filelength]     ; count of bytes
    push dword edx              ; buffer to send
    push dword [ebx+8]          ; socket handle - offset in structure
    mov ecx, esp                ; ptr to struct in stack
    mov ebx, 9                  ; send() function number
    call kSocketCall            ; call it
    add esp, 4 * 4              ; correct stack space
    
    ; first arg in eax(buffer)
    push dword strHandlerStatic
    call printf
    add esp, 4
    
.freeBuffer:
    call free                   ; relase memory(pointer in head of heap)
    pop eax                     ; stack correct (was addr of memory in heap)
        
.closeFile:
    push dword [filehandle]     ; file handle
    call fclose                 ; close file
    add esp, 4                  ; .
    jmp .endproc                ; go to end
    
.notfound:
    jmp .endproc

.endproc:

.freeMem:
    cmp dword [fullfilename], 0 ; memory allocated?
    je .correctStack      ; no? go away
    push dword [fullfilename]
    call free
    add esp, 4
    
    
.correctStack:
    mov esp, ebp    ; restore base stack pointer
    pop ebp         

    ret 4
