

; debugLine TYPE, INFO
%macro debugLine 2
    EXTERN fileDebug, fopen, fclose, fprintf, fOpenAppend, strDebugGeneral
    jmp %%code  ; go to code area
%%type: db %1, 0    ; type of message
%%info: db %2, 0    ; message

%%code:
    pusha   ; save registers
    
    push fOpenAppend    ; just 'a\0' string
    push fileDebug      ; filename
    CALL fopen          ; call fopen()
    add esp, 2 * 4      ; clean stack
        
    push eax            ; small trick - push arg for fclose
    
    push %%type         ; offset to first %s
    push %%info         ; second %s
    push strDebugGeneral; format string
    push eax            ; file handle
    CALL fprintf        ; fprintf()
    add esp, 4 * 4      ; correct stack only for fprintf
    
    CALL fclose         ; call fclose(), handle pushed before 
    add esp, 4          ; correct stack
    
%%endmacro:
    popa    ; restore back registers
    
%endmacro


