GLOBAL processRequest
EXTERN strlen, printf, fprintf, strtok, malloc, memset, strchr, free, strncmp, send
EXTERN strDebugGeneral, maxHeaders, cgiBinFolder, handlerStatic
EXTERN kSocketCall

SEGMENT .data
header_sep:      db 10, 13, 0
juststr:         db "%s",10,0


SEGMENT .code
 
STRUC tRequest, -30
  .filename:    resd    1 
  .method:      resd    1
  .socket:      resd    1
  .request:     resd    1
  .requestLen:  resd    1
ENDSTRUC

; Process user requests
; arguments: socket/(dword) request(dword,ptr)
processRequest:
    push ebp        ; preserve ebp
    mov ebp, esp    ; new local offset
    sub esp, 30     ; space for structure in stack
    %define lv_offset 30
    sub esp, lv_offset
    %define headers   ebp - 30 - lv_offset + 0
    %define i         ebp - 30 - lv_offset + 4
    %define j         ebp - 30 - lv_offset + 8
    %define buf       ebp - 30 - lv_offset + 12
    %define len       ebp - 30 - lv_offset + 16
    %define str       ebp - 30 - lv_offset + 20
    
    mov eax, dword [ebp + 8]        ; get socket id from stack
    mov dword [ebp + tRequest.socket], eax
    mov eax, dword [ebp + 12]       ; get request string
    mov dword [ebp + tRequest.request], eax

    push dword [ebp + tRequest.request] ; calculate
    call strlen         ; request length
    add esp, 4          ; cleanup stack
    mov dword [ebp + tRequest.requestLen], eax ; remember length

    push dword 0
    push '->> '
    mov eax, esp
    push dword 0
    push '<<- '
    
    push esp
    push eax
    push strDebugGeneral
    call printf
    add esp, 4 * 3
    
    
.allocBuffers:
    ;.. for header line
    push dword 1 << 14  ; 16Kb
    call malloc         ; requre some memory
    add esp, 4          ; correct stack
    mov [buf], eax      ; save pointer to memory block
    
    mov [eax], dword 0        ; length = 0
    
    ; ..for array of pointers to string(enviroment)
    mov eax, dword [maxHeaders]
    mov bl, 4
    mul bl
    push eax
    call malloc
    mov [headers], eax
    
    push dword 0
    push dword [headers]
    call memset
    add esp, 4 * 3

    ; ..for url buffer
    push dword 2048     ; maximum url length (rfc)
    call malloc         ; do allocate
    add esp, 4          ; correct stack
    mov [ebp + tRequest.filename], eax      ; save point to url
    
    

.breakHeaders:
    push dword header_sep
    push dword [ebp + tRequest.request]
    call strtok
    add esp, 4 * 2
    
    cmp eax, 0
    je  .breakHeadersEnd

.httpRequest: 
    mov [str], eax      ; save pointer to header string

    mov ebx, [str]
    mov [ebp + tRequest.method], ebx

    
    push dword ' '
    push dword [str]
    call strchr 
    add esp, 4 * 2
    mov [eax], byte 0        ; break method and url
    inc eax
    mov [ebp + tRequest.filename], eax
    
    push dword ' '
    push dword [ebp + tRequest.filename]
    call strchr
    add esp, 4 * 2
    mov [eax], byte 0        ; break url and http    
    

    push dword header_sep
    push dword 0 
    call strtok         ; AAAAAA  strtok_r
    add esp, 4 * 2

    cmp eax, 0
    je  .breakHeadersEnd
    
    
.breakHeadersLoop:
    mov [str], eax      ; save pointer to header string
    
    push dword [str]    ; get current header length
    
        
    push juststr
    call printf
    pop eax
    pop eax
    
;    jmp .breakHeadersEnd
    
    push dword header_sep
    push dword 0 
    call strtok         ; AAAAAA  strtok_r
    add esp, 4 * 2
    
    cmp eax, 0
    jne .breakHeadersLoop

.breakHeadersEnd:
    push dword [ebp + tRequest.filename]
    push dword juststr
    call printf

    mov eax, ebp
    add eax,  tRequest
    push eax
    CALL preprocessRequest
    
.endproc:

.freeBuffers:
    push dword [headers]
    call free
    push dword [buf]
    call free

    mov esp, ebp    ; restore base stack pointer
    pop ebp         
    
    ret 4 * 2
    
    

preprocessRequest:
    push ebp        ; preserve ebp
    mov ebp, esp    ; new local offset

    %define reqFilename ebp+16


    push dword 0
    push dword 10     ; count of bytes
    push dword [reqFilename]
    push dword [ebp+8]
    pop eax
    add eax, 8
    push eax
    call send
    add esp, 4*4


    push dword cgiBinFolder ; get '/cgi-bin'
    call strlen             ; get length of string
    add esp, 4              ; correct stack
    
    push eax                ; compare length is a last argument
    push dword cgiBinFolder ; address of string
    push dword [reqFilename]; addr of file name
    call strncmp            ; compare start of strings
    add esp, 4 * 3          ; correct stack
    cmp eax, 0              ; is start are same in both strings?
    jz .cgiHere             ; hey! there is cgi program!
    
.staticHere:
    mov ebx, ebp        ; filename - first field in structure
    add ebx, 16
    push dword [ebx]
    call handlerStatic      ; call static content processor
    jmp .endproc

.cgiHere: 
    jmp .cgiHereNext
.cgiherestring:
    db 'Hey! There is cgi interface!', 10, 0
.cgiHereNext:
    push dword .cgiherestring
    call printf
    add esp, 4
    jmp .endproc
    

.endproc:

    mov esp, ebp    ; restore base stack pointer
    pop ebp         
    
    ret 4
